import java.util.Scanner;
import java.io.PrintStream;
import java.io.*;

public class DigitalCircuit {
  public static void main(String argv[]) {
    Simulator sim = new Simulator ();
    Or or0 = new Or (0.5f, sim);
    Or or1 = new Or (2f, sim);
    Not not0 = new Not (0.5f, sim);
    Not not1 = new Not (0.5f, sim);
    
    Wire w0 = new Wire();
    Wire w1 = new Wire();
    Wire w2 = new Wire();
    Wire w3 = new Wire();
    Wire w4 = new Wire();
    Wire w5 = new Wire();
    
    Source r = new Source(getScanner(argv[0]), sim);
    Source s = new Source(getScanner(argv[1]), sim);
    Meter meter = new Meter(getPrintStream(argv[2]));

    r.connectOutput(w0);
    or0.connectInputA(w0);
    or0.connectOutput(w1);
    or0.connectInputB(w5);
    
    not0.connectInput(w1);
    not0.connectOutput(w2);
    
    s.connectOutput(w3);
    or1.connectInputA(w2);
    or1.connectInputB(w3);
    or1.connectOutput(w4);
    
    not1.connectInput(w4);
    not1.connectOutput(w5);
    
    meter.addTestPoint(w0);
    meter.addTestPoint(w3);
    meter.addTestPoint(w2);
    meter.addTestPoint(w5);
    /* Here we check that each gate
       output agrees the gate logic. */
    or0.inputChanged();  /* b)  */
    or1.inputChanged();  /* b)  */
    not0.inputChanged(); /* b)  */
    not1.inputChanged(); /* b)  */
    
    sim.simulate(meter);
  }
  private static Scanner getScanner(String filename){
    Scanner s=null;
    try {
       s=new Scanner(new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return s;
  }
  private static PrintStream getPrintStream(String filename) {
    PrintStream out=null;
    try {
      out = new PrintStream( new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return out;
  }
} 
